<template>
  <div class="q-pa-md">
    <product-carousel class="carousel" />
    <q-separator inset />
    <div
      class="row q-col-gutter-xl items-center justify-center q-my-md q-mx-lg q-px-xl"
      :class="mobilePadding"
    >
      <div class="column items-center q-px-lg col-xs-12 col-sm-4 col-4">
        <q-icon size="80px" class="text-primary" name="card_giftcard" />
        <p
          class="text-subtitle2 text-weight-light q-mt-md q-mx-xl"
        >Promotiile regulate te fac sa nu renunti la fusta pe care ti-ai dorit-o sau la cadoul pentru prietene.</p>
      </div>
      <div class="column items-center q-px-lg col-xs-12 col-sm-4 col-4">
        <q-icon size="80px" class="text-primary" name="flare" />
        <p
          class="text-subtitle2 text-weight-light q-mt-md q-mx-xl"
        >Aici gasesti cele mai noi produse din tendinte, gata pentru tine, doar la un click distanta.</p>
      </div>
      <div class="column items-center q-px-lg col-xs-12 col-sm-4 col-4">
        <q-icon size="80px" class="text-primary" name="flight_takeoff" />
        <p
          class="text-subtitle2 text-weight-light q-mt-md q-mx-xl"
        >Colaboram cu cele mai rapide firme de curierat din tara pentru a fi siguri ca produsul ajunge la tine in cel mai scurt timp.</p>
      </div>
    </div>
    <hr class="hr-text q-py-lg text-weight-bold" data-content="PRODUSE SPECIALE" />

    <div class="full-width row inline wrap justify-center items-center content-start">
      <div
        class="child column items-center col-xs-12 col-sm-4 col-4 cursor-pointer card q-px-md q-pt-md"
        v-for="product in products"
        :key="product.id"
        @click="openProduct(product.id)"
      >
        <q-img :src="product.image" style="height: 200px; max-width: 150px"></q-img>
        <p
          class="text-subtitle1 text-weight-medium text-capitalize q-mt-md q-mb-none"
        >{{ product.name }}</p>
        <p class="text-subtitle1 text-primary q-mt-none">{{ product.price }} RON</p>
      </div>
    </div>
    <div
      class="row q-px-xl q-py-lg q-my-md special-section"
      style="margin-bottom: 100px; height: 350px; max-height: 600px; background-color: #f2f2f2;"
    >
      <div class="col-5 col-xs-12 q-ml-xl">
        <h5 class="text-h5">
          Descopera produsele din categoria
          <span
            class="text-h4 text-weight-medium"
          >{{oneCategory.name}}.</span>
        </h5>
        <div class="row">
          <h4 class="text-h4 q-mt-none"></h4>
          <q-btn
            outline
            style="height: 50px;"
            class="text-weight-medium"
            icon-right="chevron_right"
            color="accent"
            @click="openCategory(oneCategory.name)"
            label="Porneste acum "
          />
        </div>
      </div>
      <q-separator inset />
    </div>
  </div>
</template>

<script>
import ProductCarousel from "components/client/Carousel.vue";
import { LocalStorage } from "quasar";

export default {
  name: "home",
  components: {
    ProductCarousel,
  },

  data() {
    return {
      slide: "style",
      lorem:
        "Lorem ipsum dolor, sit amet consectetur adipisicing elit. Itaque voluptatem totam, architecto cupiditate officia rerum, error dignissimos praesentium libero ab nemo.",
    };
  },
  methods: {
    openProduct(productId) {
      this.$router.push({ name: "product", params: { product: productId } });
    },
    openCategory(category) {
      this.$router.push({ name: "categoryPage", params: { category } });
    },
  },
  computed: {
    products() {
      const products = [...this.$store.getters["adminData/getProducts"]]
        .filter(
          (item) =>
            item.preferences.reduce(
              (accumulator, currentValue) =>
                accumulator + currentValue.quantityAvailable,
              0
            ) > 0
        )
        .sort(() => 0.5 - Math.random());
      return products.slice(0, 6);
    },
    adminPreferences() {
      return this.$store.getters["adminData/getAdminPreferences"];
    },
    oneCategory() {
      const x = this.categories[
        Math.floor(Math.random() * this.categories.length)
      ];

      if (x) return x;
      else return { name: "lost" };
    },
    categories() {
      return this.$store.getters["adminData/getCategories"];
    },
    mobilePadding() {
      this.$q.platform.is.mobile ? "q-px-none" : "";
    },
  },
};
</script>

<style lang="scss" scoped>
.carousel {
  height: 50vh;
}
.child {
  overflow: auto;
  // border: 1px solid rgba(129, 128, 120, 0.4);
  p {
    text-align: center;
    color: #818078;
  }
}
.special-section {
  background: linear-gradient(157deg, $primary 0%, rgba(242, 242, 242, 1) 100%);
}
</style>
